/* the checker has three arguments:
   - first - name of the input file
   - second - name of the correct_output file
   - third - name of the contestant_output file */
#include<iostream>
#include<string.h>
#include<stdio.h>
#include<vector>
using namespace std;
void output_message (double points, const char message[]) {
    fprintf(stdout,"%f\n",points);
    fprintf(stderr,"%s\n",message);
    fflush(stdout);
    fflush(stderr);
    exit(0);
}
int main (int argc, char** argv) {
    FILE *inp,*ans,*out;
    if (argc<4) output_message(0,"The checker needs input file, correct output and contestant output!");
    inp=fopen(argv[1],"rt");
    if (!inp) output_message(0,"Could not open input file!");
    ans=fopen(argv[2],"rt");
    if (!ans) output_message(0,"Could not open correct output file!");
    out=fopen(argv[3],"rt");
    if (!out) output_message(0,"Could not open contestant output file!");

    int res;
    if (fscanf(out,"%d",&res)!=1) output_message(0,"Could not read output!");
    char message[100],t;
    if (fscanf(out,"%c%99[^\n]",&t,message)!=2) output_message(0,"Could not read output!");

    if (res==-1) output_message(0,message);
    int m1,m2;
    fscanf(inp,"%d%d",&m1,&m2);
    if ((m1<=1000)&&(m2<=1000)) output_message(1,message);
    else output_message(min(1.,36./(res+1)),message);
    return 0;
}
