#include "xylophone2.h"
#include<iostream>
#include<unordered_map>
#include<set>
#define MAXN 250
#define LOGN 8
using namespace std;
vector <int> all_diffs;
int max_diff (int to) {
    vector <int> inds;
    for (int i=0; i<=to; i++) {
        inds.push_back(i+1);
    }
    auto res=query(inds);
    int max1=0;
    for (auto diff : res) {
        max1=max(max1,diff);
    }
    if (all_diffs.size()==0) all_diffs=res;
    return max1;
}
vector <int> calc_diffs (vector <int> inds, int pos) {
    /*for (auto ind : inds) {
        cout << ind << " ";
    } cout << endl ;*/
    vector <int> res1;
    int k=inds.size();
    if (k>1) res1=query(inds);
    inds.push_back(pos);
    k++;
    vector <int> res2;
    if (k*(k-1)/2==all_diffs.size()) res2=all_diffs;
    else res2=query(inds);
    multiset <int> nums;
    for (auto num : res2) {
        nums.insert(num);
    }
    for (auto num : res1) {
        nums.erase(nums.find(num));
    }
    vector <int> diffs;
    for (auto num : nums) {
        diffs.push_back(num);
    }
    /*for (auto diff : diffs) {
        cout << diff << " ";
    } cout << endl << endl ;*/
    return diffs;
}
unordered_map <int, int> diffs;
vector <int> solve (int n) {
    vector <int> ans(n);
    int diff=max_diff(n-1),max1=diff+1;
    if (n==2) {
        return {1, max1};
    }

    int l=0,r=n-1,mid;
    for (;;) {
        if (l==r-1) break;
        mid=(l+r)/2;
        if (max_diff(mid)<diff) l=mid;
        else r=mid;
    }
    int pos=r+1;
    ans[pos-1]=max1;
    for (int i=0; i<LOGN; i++) {
        vector <int> inds;
        for (int j=1; j<=n; j++) {
            if (j==pos) continue;
            if ((j&(1<<i))!=0) inds.push_back(j);
        }
        if (inds.size()==0) break;
        for (auto d : calc_diffs(inds,pos)) {
            diffs[d]|=(1<<i);
        }
    }
    for (auto [diff, pos] : diffs) {
        ans[pos-1]=max1-diff;
    }
    /*for (auto num : ans) {
        cout << num << " ";
    }
    cout << endl ;*/
    return ans;
}
