#include "xylophone2.h"
#include<iostream>
using namespace std;
int max_diff (int to) {
    vector <int> inds;
    for (int i=0; i<=to; i++) {
        inds.push_back(i+1);
    }
    vector <int> diffs=query(inds);
    int max1=0;
    for (auto diff : diffs) {
        max1=max(max1,diff);
    }
    return max1;
}
int abs (int num) {
    return (num<0)?-num:num;
}
int find_number (int diff1, int val1, int diff2, int val2) {
    int val=val1+diff1;
    if (abs(val-val2)==diff2) return val;
    return val1-diff1;
}
vector <int> solve (int n) {
    int diff=max_diff(n-1);
    if (n==2) {
        return {1,diff+1};
    }

    int l=0,r=n-1,mid;
    for (;;) {
        if (l==r-1) break;
        mid=(l+r)/2;
        if (max_diff(mid)<diff) l=mid;
        else r=mid;
    }
    vector <int> ans(n);
    ans[r]=diff+1;
    vector <int> diffs(n-1);
    for (int i=0; i<n-1; i++) {
        diffs[i]=query({i+1,i+2})[0];
    }
    ans[r-1]=ans[r]-diffs[r-1];
    for (int i=r-2; i>=0; i--) {
        ans[i]=find_number(diffs[i],ans[i+1],query({i+1,i+3})[0],ans[i+2]);
    }
    for (int i=r+1; i<n; i++) {
        ans[i]=find_number(diffs[i-1],ans[i-1],query({i-1,i+1})[0],ans[i-2]);
    }
    return ans;
}
