#include "xylophone2.h"
#include<iostream>
#include<set>
#define MAXN 250
using namespace std;
int max_diff (int to) {
    vector <int> inds;
    for (int i=0; i<=to; i++) {
        inds.push_back(i+1);
    }
    vector <int> diffs=query(inds);
    int max1=0;
    for (auto diff : diffs) {
        max1=max(max1,diff);
    }
    return max1;
}
vector <int> calc_diffs (vector <int> inds, int pos) {
    /*for (auto ind : inds) {
        cout << ind << " ";
    } cout << endl ;*/
    vector <int> res1;
    if (inds.size()>1) res1=query(inds);
    inds.push_back(pos);
    vector <int> res2=query(inds);
    multiset <int> nums;
    for (auto num : res2) {
        nums.insert(num);
    }
    for (auto num : res1) {
        nums.erase(nums.find(num));
    }
    vector <int> diffs;
    for (auto num : nums) {
        diffs.push_back(num);
    }
    /*for (auto diff : diffs) {
        cout << diff << " ";
    } cout << endl << endl ;*/
    return diffs;
}
int diffs[MAXN];
void find_diffs (vector <int>& inds, vector <int> nums, int pos) {
    int k=inds.size();
    if (k==1) {
        diffs[inds[0]-1]=nums[0];
        return ;
    }
    vector <int> l,r;
    for (int i=0; i<k; i++) {
        if (i<k/2) l.push_back(inds[i]);
        else r.push_back(inds[i]);
    }
    vector <int> l_nums=calc_diffs(l,pos);
    find_diffs(l,l_nums,pos);
    set <int> temp;
    for (auto num : nums) {
        temp.insert(num);
    }
    for (auto num : l_nums) {
        temp.erase(num);
    }
    vector <int> r_nums;
    for (auto num : temp) {
        r_nums.push_back(num);
    }
    find_diffs(r,r_nums,pos);
}
vector <int> solve (int n) {
    int diff=max_diff(n-1);
    if (n==2) {
        return {1,diff+1};
    }

    int l=0,r=n-1,mid;
    for (;;) {
        if (l==r-1) break;
        mid=(l+r)/2;
        if (max_diff(mid)<diff) l=mid;
        else r=mid;
    }
    vector <int> inds;
    for (int i=1; i<=n; i++) {
        if (i==r+1) continue;
        inds.push_back(i);
    }
    diffs[r]=0;
    find_diffs(inds,calc_diffs(inds,r+1),r+1);

    vector <int> ans(n);
    for (int i=0; i<n; i++) {
        ans[i]=(diff+1)-diffs[i];
        //cout << ans[i] << " ";
    }
    return ans;
}
