#include<iostream>
#include<algorithm>
#include<stdio.h>
#include<vector>
#include<string>
using namespace std;
static int n,subtask;
static void finish (string message) {
    cout << message << endl ;
    exit(0);
}
static vector <int> a;
static int cnt=0;
static int abs1 (int num) {
    return (num<0)?-num:num;
}
vector <int> query (vector <int> inds) {
    cnt++;
    if ((inds.size()<2)||(inds.size()>n)) finish("Invalid size "+to_string(inds.size()));
    for (auto& i : inds) {
        i--;
        if ((i<0)||(i>=n)) finish("Invalid index "+to_string(i+1));
    }
    sort(inds.begin(),inds.end());
    for (int i=1; i<inds.size(); i++) {
        if (inds[i]==inds[i-1]) finish("Repeated indices");
    }
    vector <int> result;
    for (int i=0; i<inds.size(); i++) {
        for (int j=i+1; j<inds.size(); j++) {
            result.push_back(abs1(a[inds[j]]-a[inds[i]]));
        }
    }
    random_shuffle(result.begin(),result.end());
    return result;
}
extern vector <int> solve(int);
int main () {
    cin >> n ;
    a.resize(n);
    for (int i=0; i<n; i++) {
        cin >> a[i] ;
    }
    auto ans=solve(n);
    for (int i=0; i<n; i++) {
        cout << ans[i] << " ";
    }
    cout << endl ;
    for (int i=0; i<n; i++) {
        if (a[i]!=ans[i]) {
            cout << i << " " << a[i] << " " << ans[i] << endl ;
            finish("Wrong answer");
        }
    }
    cout << cnt ;
    cout << endl ;
    return 0;
}
